#include <string.h>
#include <stdio.h>

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "MEM_guardedalloc.h"
#include "MEM_CacheLimiterC-Api.h"

#ifdef INTERNATIONAL
#include "BIF_language.h"
#endif

#include "IMB_imbuf_types.h"
#include "IMB_imbuf.h"

#include "BLI_blenlib.h"
#include "BLI_arithb.h"
#include "BLI_gsqueue.h"
#include "BLI_linklist.h"

#include "DNA_action_types.h"
#include "DNA_armature_types.h"
#include "DNA_curve_types.h"
#include "DNA_group_types.h" /* used for select_same_group */
#include "DNA_image_types.h"
#include "DNA_ipo_types.h"
#include "DNA_mesh_types.h"
#include "DNA_meshdata_types.h"
#include "DNA_modifier_types.h" /* used for select grouped hooks */
#include "DNA_object_types.h"
#include "DNA_scene_types.h"
#include "DNA_screen_types.h"
#include "DNA_sequence_types.h"
#include "DNA_sound_types.h"
#include "DNA_space_types.h"
#include "DNA_userdef_types.h"
#include "DNA_view2d_types.h"
#include "DNA_view3d_types.h"
#include "DNA_text_types.h"

#include "BKE_blender.h"
#include "BKE_colortools.h"
#include "BKE_curve.h"
#include "BKE_depsgraph.h"
#include "BKE_displist.h"
#include "BKE_global.h"
#include "BKE_group.h"
#include "BKE_ipo.h"
#include "BKE_main.h"
#include "BKE_mesh.h"
#include "BKE_node.h"
#include "BKE_scene.h"
#include "BKE_utildefines.h"

#include "BIF_spacetypes.h"  /* first, nasty dependency with typedef */

#include "BIF_butspace.h"
#include "BIF_drawimage.h"
#include "BIF_drawseq.h"
#include "BIF_drawtext.h"
#include "BIF_drawscript.h"
#include "BIF_editarmature.h"
#include "BIF_editconstraint.h"
#include "BIF_editfont.h"
#include "BIF_editgroup.h"
#include "BIF_editkey.h"
#include "BIF_editlattice.h"
#include "BIF_editmesh.h"
#include "BIF_editmode_undo.h"
#include "BIF_editnla.h"
#include "BIF_editoops.h"
#include "BIF_editseq.h"
#include "BIF_editsima.h"
#include "BIF_editsound.h"
#include "BIF_editview.h"
#include "BIF_gl.h"
#include "BIF_imasel.h"
#include "BIF_interface.h"
#include "BIF_interface_icons.h"
#include "BIF_meshtools.h"
#include "BIF_mywindow.h"
#include "BIF_oops.h"
#include "BIF_poseobject.h"
#include "BIF_outliner.h"
#include "BIF_resources.h"
#include "BIF_retopo.h"
#include "BIF_screen.h"
#include "BIF_space.h"
#include "BIF_toets.h"
#include "BIF_toolbox.h"
#include "BIF_usiblender.h"
#include "BIF_previewrender.h"

#include "BSE_edit.h"
#include "BSE_view.h"
#include "BSE_editipo.h"
#include "BSE_drawipo.h"
#include "BSE_drawview.h"
#include "BSE_drawnla.h"
#include "BSE_filesel.h"
#include "BSE_headerbuttons.h"
#include "BSE_editnla_types.h"
#include "BSE_time.h"

#include "BDR_vpaint.h"
#include "BDR_editmball.h"
#include "BDR_editobject.h"
#include "BDR_editcurve.h"
#include "BDR_editface.h"
#include "BDR_drawmesh.h"
#include "BDR_drawobject.h"
#include "BDR_imagepaint.h"
#include "BDR_sculptmode.h"
#include "BDR_unwrapper.h"

#include "BLO_readfile.h" /* for BLO_blendhandle_close */

#include "PIL_time.h"

#include "BPY_extern.h"

#include "butspace.h"
#include "mydevice.h"
#include "blendef.h"
#include "datatoc.h"
#include "multires.h"

#include "BIF_transform.h"

#include "BKE_depsgraph.h"

#include "BSE_trans_types.h"

#include "SYS_System.h" /* for the user def menu ... should move elsewhere. */

#include "PIL_dynlib.h"
#include "extern_engine_interface.h"

short getversion(void){
  return G.version;
}

Main *getmain(){
  return G.main;
}

Mesh *getmesh(Object *obj){
  return get_mesh(obj);
}

void runpythonscript(char *text,int len){
  SpaceBeei *sge= curarea->spacedata.first;
  int i;

  sge->text=add_empty_text( "beei script" );
  for (i=0;i<len;i++)
    if ((char)*(text+i)==0)
      txt_split_curline(sge->text);
    else
      txt_add_char(sge->text,(char)*(text+i));
  BPY_txt_do_python_Text(sge->text);
}

uiBlock *createnewblock(char *name){
  return uiNewBlock(&curarea->uiblocks, name, UI_EMBOSS, UI_HELV, curarea->win);
}

int createnewpanel(uiBlock *block,char *name){
  return uiNewPanel(curarea, block, name, "UI", 0, 0, 320, 240);
}

void addpaneltab(char *name){
  uiNewPanelTabbed(name, "UI");
}

void addbutton(uiBlock *block,char *name,char *hint, int x1,int y1,int x2,int y2, unsigned long event){
  uiDefBut(block, BUT,event,name,	x1, y1, x2,y2, 0, 0, 0, 0, 0, hint);
}

void blockbegin(uiBlock *block){
  uiBlockBeginAlign(block);
}

void blockend(uiBlock *block){
  uiBlockEndAlign(block);
}

void addlabel(uiBlock *block,char *name,char *hint, int x1,int y1,int x2,int y2){
  uiDefBut(block, LABEL, 0, name,	x1, y1, x2,y2, 0, 0, 0, 0, 0, hint);
}

void addcheckbox(uiBlock *block,char *name,char *hint, int x1,int y1,int x2,int y2, unsigned long event,void *data){
  uiDefButI(block, TOG, event,name,x1, y1, x2, y2, data, 0, 0, 0, 0, hint);
}

void addslider(uiBlock *block,char *name,char *hint, int x1,int y1,int x2,int y2,float min,float max, float steps, unsigned long event,void *data){
  uiDefButF(block, NUM, event,name,x1, y1, x2, y2, data, min, max, steps, 0, hint);
}

void addtext(uiBlock *block,char *name,char *hint, int x1,int y1,int x2,int y2,float len,unsigned long event,void *data){
  uiDefButC(block, TEX, event,name,x1,y1,x2,y2,data,1.0,len,0,0,hint);
}

void addmenu(uiBlock *block,char *name,char *hint, int x1,int y1,int x2,int y2,unsigned long event,void *data){
  uiDefButS(block, MENU,event,name,x1,y1,x2,y2,data,0,0,0,0,hint);
}

void addcolbtn(uiBlock *block,char *name,char *hint, int x1,int y1,int x2,int y2,unsigned long event,void *data){
  uiDefButC(block, COL,event,name,x1,y1,x2,y2,data,0,0,0,0,hint);
}

void addiconbtn(uiBlock *block,int icon,char *hint, int x1,int y1,int x2,int y2,unsigned long event){
  uiDefIconBut(block,BUT,event,icon,x1,y1,x2,y2,0,0,0,0,0,hint);
}

void *getfunctionptr(char *name){
  if (strcmp(name,"getversion")==0){
    return &getversion;
  } else
  if (strcmp(name,"getmain")==0){
    return &getmain;
  } else
  if (strcmp(name,"getmesh")==0){
    return &getmesh;
  } else
  if (strcmp(name,"runpythonscript")==0){
    return &runpythonscript;
  } else
  if (strcmp(name,"createnewblock")==0){
    return &createnewblock;
  } else
  if (strcmp(name,"createnewpanel")==0){
    return &createnewpanel;
  } else
  if (strcmp(name,"addpaneltab")==0){
    return &addpaneltab;
  } else
  if (strcmp(name,"addbutton")==0){
    return &addbutton;
  } else
  if (strcmp(name,"blockbegin")==0){
    return &blockbegin;
  } else
  if (strcmp(name,"blockend")==0){
    return &blockend;
  } else
  if (strcmp(name,"addlabel")==0){
    return &addlabel;
  } else
  if (strcmp(name,"addcheckbox")==0){
    return &addcheckbox;
  } else
  if (strcmp(name,"addslider")==0){
    return &addslider;
  } else
  if (strcmp(name,"addtext")==0){
    return &addtext;
  } else
  if (strcmp(name,"addmenu")==0){
    return &addmenu;
  } else
  if (strcmp(name,"addcolbtn")==0){
    return &addcolbtn;
  } else
  if (strcmp(name,"addiconbtn")==0){
    return &addiconbtn;
  }
  return NULL;
}

void add_beei_fs(char *file)
{
	SpaceBeei *sge= curarea->spacedata.first;
	sge->filename=file;

//load engine library
        if (sge->gelib!=NULL)
          PIL_dynlib_close(sge->gelib);
        sge->gelib=NULL;
        sge->gelib=PIL_dynlib_open(file);
        if (sge->gelib==NULL)
          printf("Dynamic Library %s could not loaded.\n",sge->filename);
        else
          printf("Dynymic Library %s are loaded.\n",sge->filename);

//load engine callbacks
        beei_startup = PIL_dynlib_find_symbol(sge->gelib, "startup");
        if (beei_startup==NULL)
          printf("%s: error %s\n",sge->filename,PIL_dynlib_get_error_as_string(sge->gelib));
        else{
          beei_startup(&getfunctionptr);
        }

        beei_draw = PIL_dynlib_find_symbol(sge->gelib, "draw");
        if (beei_draw==NULL)
          printf("%s: error %s\n",sge->filename,PIL_dynlib_get_error_as_string(sge->gelib));

        beei_start = PIL_dynlib_find_symbol(sge->gelib, "start");
        if (beei_start==NULL)
          printf("%s: error %s\n",sge->filename,PIL_dynlib_get_error_as_string(sge->gelib));

        beei_stop = PIL_dynlib_find_symbol(sge->gelib, "stop");
        if (beei_stop==NULL)
          printf("%s: error %s\n",sge->filename,PIL_dynlib_get_error_as_string(sge->gelib));

        beei_drawui = PIL_dynlib_find_symbol(sge->gelib, "drawui");
        if (beei_drawui==NULL)
          printf("%s: error %s\n",sge->filename,PIL_dynlib_get_error_as_string(sge->gelib));
        
        beei_event = PIL_dynlib_find_symbol(sge->gelib, "event");
        if (beei_event==NULL)
          printf("%s: error %s\n",sge->filename,PIL_dynlib_get_error_as_string(sge->gelib));

	allqueue(REDRAWBEEI, 0);
	allqueue(REDRAWHEADERS, 0);
}

void drawbeeiui(ScrArea *sa,SpaceBeei *sge){
  myortho2(-0.375f, sa->winx - 0.375f, -0.375f, sa->winy - 0.375f);

  glDisable(GL_DEPTH_TEST);

  bwin_scalematrix(sa->win, sge->blockscale, sge->blockscale, sge->blockscale);

  uiFreeBlocksWin(&sa->uiblocks, sa->win);

  if (beei_drawui!=NULL)
    beei_drawui();

  uiDrawBlocksPanels(sa, 0);
}
